- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# OsiCpxSolverInterface Class Reference

CPLEX Solver Interface. More...

`#include <OsiCpxSolverInterface.hpp>`

Inheritance diagram for OsiCpxSolverInterface:

[legend]
Collaboration diagram for OsiCpxSolverInterface:

[legend]
List of all members.

## CPLEX specific public interfaces
enum | keepCachedFlag { KEEPCACHED_NONE = 0, KEEPCACHED_COLUMN = 1, KEEPCACHED_ROW = 2, KEEPCACHED_MATRIX = 4, KEEPCACHED_RESULTS = 8, KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX, KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS, FREECACHED_COLUMN = KEEPCACHED_PROBLEM & ~KEEPCACHED_COLUMN, FREECACHED_ROW = KEEPCACHED_PROBLEM & ~KEEPCACHED_ROW, FREECACHED_MATRIX = KEEPCACHED_PROBLEM & ~KEEPCACHED_MATRIX, FREECACHED_RESULTS = KEEPCACHED_ALL & ~KEEPCACHED_RESULTS }
| Get pointer to CPLEX model and free all specified cached data entries (combined with logical or-operator '|' ):. More...
CPXLPptr | getLpPtr (int keepCached=KEEPCACHED_NONE)
| Get pointer to CPLEX model and free all specified cached data entries (combined with logical or-operator '|' ):.
CPXENVptr | getEnvironmentPtr ()
| Method to access CPLEX environment pointer.
## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
const char * | getCtype () const
| return a vector of variable types (continous, binary, integer)
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
bool | setDblParam (OsiDblParam key, double value)
bool | setStrParam (OsiStrParam key, const std::string &value)
bool | getIntParam (OsiIntParam key, int &value) const
bool | getDblParam (OsiDblParam key, double &value) const
bool | getStrParam (OsiStrParam key, std::string &value) const
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get an empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setObjCoeffSet (const int *indexFirst, const int *indexLast, const double *coeffList)
| Set a a set of objective function coefficients.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes `setColLower()` and `setColUpper()`.
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes `setCollower()` and `setColupper()` over and over again.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes `setRowLower()` and `setRowUpper()`.
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes `setRowType()` and over and over again.
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
Constructors and destructor
| OsiCpxSolverInterface ()
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiCpxSolverInterface (const OsiCpxSolverInterface &)
| Copy constructor.
OsiCpxSolverInterface & | operator= (const OsiCpxSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiCpxSolverInterface ()
| Destructor.
virtual void | reset ()
| Resets as if default constructor.
OsiSimplexInterface methods
Cplex adds a slack with coeff +1 in "<=" and "=" constraints, with coeff -1 in ">=", slack being non negative. We switch in order to get a "Clp tableau" where all the slacks have coefficient +1 in the original tableau. If a slack for ">=" is non basic, invB is not changed; column of the slack in the optimal tableau is flipped. If a slack for ">=" is basic, corresp. row of invB is flipped; whole row of the optimal tableau is flipped; then whole column for the slack in opt tableau is flipped. Ranged rows are not supported. It might work, but no garantee is given. Code implemented only for Cplex9.0 and higher, lower version number of Cplex will abort the code.
virtual int | canDoSimplexInterface () const
| Returns 1 if can just do getBInv etc 2 if has all OsiSimplex methods and 0 if it has none.
virtual void | enableSimplexInterface (int doingPrimal)
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual void | disableSimplexInterface ()
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual void | enableFactorization () const
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual void | disableFactorization () const
| Useless function, defined only for compatibility with OsiSimplexInterface.
virtual bool | basisIsAvailable () const
| Returns true if a basis is available.
virtual void | getBasisStatus (int *cstat, int *rstat) const
| Returns a basis status of the structural/artificial variables At present as warm start i.e 0: free, 1: basic, 2: upper, 3: lower.
virtual void | getBInvARow (int row, double *z, double *slack=NULL) const
| Get a row of the tableau (slack part in slack if not NULL).
virtual void | getBInvRow (int row, double *z) const
| Get a row of the basis inverse.
virtual void | getBInvACol (int col, double *vec) const
| Get a column of the tableau.
virtual void | getBInvCol (int col, double *vec) const
| Get a column of the basis inverse.
virtual void | getBasics (int *index) const
| Get indices of the pivot variable in each row (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).
## Static Public Member Functions
Static instance counter methods
static void | incrementInstanceCounter ()
| CPLEX has a context which must be created prior to all other CPLEX calls.
static void | decrementInstanceCounter ()
| CPLEX has a context which should be deleted after CPLEX calls.
static unsigned int | getNumInstances ()
| Return the number of instances of instantiated objects using CPLEX services.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied.
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment).
## Private Member Functions
Private static class functions
void | switchToLP ()
| switches CPLEX to prob type LP
void | switchToMIP ()
| switches CPLEX to prob type MIP
void | resizeColType (int minsize)
| resizes coltype_ vector to be able to store at least minsize elements
void | freeColType ()
| frees colsize_ vector
Private methods
CPXLPptr | getMutableLpPtr () const
| Get LP Pointer for const methods.
void | gutsOfCopy (const OsiCpxSolverInterface &source)
| The real work of a copy constructor (used by copy and assignment).
void | gutsOfConstructor ()
| The real work of the constructor.
void | gutsOfDestructor ()
| The real work of the destructor.
void | freeCachedColRim ()
| free cached column rim vectors
void | freeCachedRowRim ()
| free cached row rim vectors
void | freeCachedResults ()
| free cached result vectors
void | freeCachedMatrix ()
| free cached matrices
void | freeCachedData (int keepCached=KEEPCACHED_NONE)
| free all cached data (except specified entries, see getLpPtr())
void | freeAllMemory ()
| free all allocated memory
void | printBounds ()
| Just for testing purposes.
## Private Attributes
Private member data
CPXLPptr | lp_
| CPLEX model represented by this class instance.
int * | hotStartCStat_
| Hotstart information.
int | hotStartCStatSize_
| CPLEX model represented by this class instance.
int * | hotStartRStat_
| CPLEX model represented by this class instance.
int | hotStartRStatSize_
| CPLEX model represented by this class instance.
int | hotStartMaxIteration_
| CPLEX model represented by this class instance.
Cached information derived from the CPLEX model
double * | obj_
| Pointer to objective vector.
double * | collower_
| Pointer to dense vector of variable lower bounds.
double * | colupper_
| Pointer to dense vector of variable lower bounds.
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
double * | rowlower_
| Pointer to dense vector of row lower bounds.
double * | rowupper_
| Pointer to dense vector of row upper bounds.
double * | colsol_
| Pointer to primal solution vector.
double * | rowsol_
| Pointer to dual solution vector.
double * | redcost_
| Pointer to reduced cost vector.
double * | rowact_
| Pointer to row activity (slack) vector.
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients.
Additional information needed for storing MIP problems
char * | coltype_
| Pointer to dense vector of variable types (continous, binary, integer).
int | coltypesize_
| Size of allocated memory for coltype_.
bool | probtypemip_
| Stores whether CPLEX' prob type is currently set to MIP.
## Static Private Attributes
Private static class data
static CPXENVptr | env_
| CPLEX environment pointer.
static int | cpxVersionMajor_
| CPLEX version.
static int | cpxVersionMinor_
| CPLEX environment pointer.
static int | cpxVersionMinorMinor_
| CPLEX environment pointer.
static unsigned int | numInstances_
| Number of live problem instances.
## Friends
void | OsiCpxSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiOslSolverInterface class.

## Detailed Description

CPLEX Solver Interface.

Instantiation of OsiCpxSolverInterface for CPLEX

Definition at line 35 of file OsiCpxSolverInterface.hpp.

## Member Enumeration Documentation

enum OsiCpxSolverInterface::keepCachedFlag

Get pointer to CPLEX model and free all specified cached data entries (combined with logical or-operator '|' ):.

Enumerator:

  KEEPCACHED_NONE | discard all cached data (default)
  KEEPCACHED_COLUMN | column information: objective values, lower and upper bounds, variable types
  KEEPCACHED_ROW | row information: right hand sides, ranges and senses, lower and upper bounds for row
  KEEPCACHED_MATRIX | problem matrix: matrix ordered by column and by row
  KEEPCACHED_RESULTS | LP solution: primal and dual solution, reduced costs, row activities.
  KEEPCACHED_PROBLEM | only discard cached LP solution
  KEEPCACHED_ALL | keep all cached data (similar to getMutableLpPtr())
  FREECACHED_COLUMN | free only cached column and LP solution information
  FREECACHED_ROW | free only cached row and LP solution information
  FREECACHED_MATRIX | free only cached matrix and LP solution information
  FREECACHED_RESULTS | free only cached LP solution information

Definition at line 600 of file OsiCpxSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiCpxSolverInterface::OsiCpxSolverInterface | ( |  | ) |

Default Constructor.

OsiCpxSolverInterface::OsiCpxSolverInterface | ( | const OsiCpxSolverInterface & |  | ) |

Copy constructor.

virtual OsiCpxSolverInterface::~OsiCpxSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiCpxSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiCpxSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiCpxSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiCpxSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiCpxSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiCpxSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiCpxSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

CoinWarmStart* OsiCpxSolverInterface::getEmptyWarmStart | ( |  | ) | const`[inline, virtual]`

Get an empty warm start object.

This routine returns an empty CoinWarmStartBasis object. Its purpose is to provide a way to give a client a warm start basis object of the appropriate type, which can resized and modified as desired.

Implements OsiSolverInterface.

Definition at line 112 of file OsiCpxSolverInterface.hpp.

virtual CoinWarmStart* OsiCpxSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiCpxSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiCpxSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiCpxSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiCpxSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiCpxSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiCpxSolverInterface::isContinuous | ( | int | colNumber | ) | const`[virtual]`

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiCpxSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiCpxSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiCpxSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getRowPrice | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getReducedCost | ( |  | ) | const`[virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiCpxSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiCpxSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiCpxSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiCpxSolverInterface::getDualRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiCpxSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setObjCoeffSet | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | coeffList |
| ) |  |  | `[virtual]`

Set a a set of objective function coefficients.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound
Use -DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound
Use DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single column lower and upper bound
The default implementation just invokes `setColLower()` and `setColUpper()`.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of columns simultaneously
The default implementation just invokes `setCollower()` and `setColupper()` over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound
Use -DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound
Use DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single row lower and upper bound
The default implementation just invokes `setRowLower()` and `setRowUpper()`.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of rows simultaneously
The default implementation just invokes `setRowLower()` and `setRowUpper()` over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a number of rows simultaneously
The default implementation just invokes `setRowType()` and over and over again.

Parameters:

  | <code>[indexfirst,indexLast]</code> | contains the indices of the constraints whose type changes
  | senseList | the new senses
  | rhsList | the new right hand sides
  | rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiCpxSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

CPXLPptr OsiCpxSolverInterface::getLpPtr | ( | int | keepCached = `KEEPCACHED_NONE` | ) |

Get pointer to CPLEX model and free all specified cached data entries (combined with logical or-operator '|' ):.

CPXENVptr OsiCpxSolverInterface::getEnvironmentPtr | ( |  | ) |

Method to access CPLEX environment pointer.

const char* OsiCpxSolverInterface::getCtype | ( |  | ) | const

return a vector of variable types (continous, binary, integer)

static void OsiCpxSolverInterface::incrementInstanceCounter | ( |  | ) | `[static]`

CPLEX has a context which must be created prior to all other CPLEX calls.

This method:

- Increments by 1 the number of uses of the CPLEX environment.
- Creates the CPLEX context when the number of uses is change to 1 from 0.

static void OsiCpxSolverInterface::decrementInstanceCounter | ( |  | ) | `[static]`

CPLEX has a context which should be deleted after CPLEX calls.

This method:

- Decrements by 1 the number of uses of the CPLEX environment.
- Deletes the CPLEX context when the number of uses is change to 0 from 1.

static unsigned int OsiCpxSolverInterface::getNumInstances | ( |  | ) | `[static]`

Return the number of instances of instantiated objects using CPLEX services.

virtual OsiSolverInterface* OsiCpxSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiCpxSolverInterface& OsiCpxSolverInterface::operator= | ( | const OsiCpxSolverInterface & | rhs | ) |

Assignment operator.

virtual void OsiCpxSolverInterface::reset | ( |  | ) | `[virtual]`

Resets as if default constructor.

Reimplemented from OsiSolverInterface.

virtual int OsiCpxSolverInterface::canDoSimplexInterface | ( |  | ) | const`[virtual]`

Returns 1 if can just do getBInv etc 2 if has all OsiSimplex methods and 0 if it has none.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::enableSimplexInterface | ( | int | doingPrimal | ) | `[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Definition at line 712 of file OsiCpxSolverInterface.hpp.

virtual void OsiCpxSolverInterface::disableSimplexInterface | ( |  | ) | `[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Reimplemented from OsiSolverInterface.

Definition at line 717 of file OsiCpxSolverInterface.hpp.

virtual void OsiCpxSolverInterface::enableFactorization | ( |  | ) | const`[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Reimplemented from OsiSolverInterface.

Definition at line 722 of file OsiCpxSolverInterface.hpp.

virtual void OsiCpxSolverInterface::disableFactorization | ( |  | ) | const`[inline, virtual]`

Useless function, defined only for compatibility with OsiSimplexInterface.

Reimplemented from OsiSolverInterface.

Definition at line 727 of file OsiCpxSolverInterface.hpp.

virtual bool OsiCpxSolverInterface::basisIsAvailable | ( |  | ) | const`[virtual]`

Returns true if a basis is available.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::getBasisStatus | ( | int * | cstat,
|  | int * | rstat |
| ) |  |  | const`[virtual]`

Returns a basis status of the structural/artificial variables At present as warm start i.e 0: free, 1: basic, 2: upper, 3: lower.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::getBInvARow | ( | int | row,
|  | double * | z,
|  | double * | slack = `NULL` |
| ) |  |  | const`[virtual]`

Get a row of the tableau (slack part in slack if not NULL).

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::getBInvRow | ( | int | row,
|  | double * | z |
| ) |  |  | const`[virtual]`

Get a row of the basis inverse.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::getBInvACol | ( | int | col,
|  | double * | vec |
| ) |  |  | const`[virtual]`

Get a column of the tableau.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::getBInvCol | ( | int | col,
|  | double * | vec |
| ) |  |  | const`[virtual]`

Get a column of the basis inverse.

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::getBasics | ( | int * | index | ) | const`[virtual]`

Get indices of the pivot variable in each row (order of indices corresponds to the order of elements in a vector retured by getBInvACol() and getBInvCol()).

Reimplemented from OsiSolverInterface.

virtual void OsiCpxSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiCpxSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

void OsiCpxSolverInterface::switchToLP | ( |  | ) | `[private]`

switches CPLEX to prob type LP

void OsiCpxSolverInterface::switchToMIP | ( |  | ) | `[private]`

switches CPLEX to prob type MIP

void OsiCpxSolverInterface::resizeColType | ( | int | minsize | ) | `[private]`

resizes coltype_ vector to be able to store at least minsize elements

void OsiCpxSolverInterface::freeColType | ( |  | ) | `[private]`

frees colsize_ vector

CPXLPptr OsiCpxSolverInterface::getMutableLpPtr | ( |  | ) | const`[private]`

Get LP Pointer for const methods.

void OsiCpxSolverInterface::gutsOfCopy | ( | const OsiCpxSolverInterface & | source | ) | `[private]`

The real work of a copy constructor (used by copy and assignment).

void OsiCpxSolverInterface::gutsOfConstructor | ( |  | ) | `[private]`

The real work of the constructor.

void OsiCpxSolverInterface::gutsOfDestructor | ( |  | ) | `[private]`

The real work of the destructor.

void OsiCpxSolverInterface::freeCachedColRim | ( |  | ) | `[private]`

free cached column rim vectors

void OsiCpxSolverInterface::freeCachedRowRim | ( |  | ) | `[private]`

free cached row rim vectors

void OsiCpxSolverInterface::freeCachedResults | ( |  | ) | `[private]`

free cached result vectors

void OsiCpxSolverInterface::freeCachedMatrix | ( |  | ) | `[private]`

free cached matrices

void OsiCpxSolverInterface::freeCachedData | ( | int | keepCached = `KEEPCACHED_NONE` | ) | `[private]`

free all cached data (except specified entries, see getLpPtr())

void OsiCpxSolverInterface::freeAllMemory | ( |  | ) | `[private]`

free all allocated memory

void OsiCpxSolverInterface::printBounds | ( |  | ) | `[private]`

Just for testing purposes.

## Friends And Related Function Documentation

void OsiCpxSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiOslSolverInterface class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging.

## Member Data Documentation

CPXENVptr OsiCpxSolverInterface::env_`[static, private]`

CPLEX environment pointer.

Definition at line 790 of file OsiCpxSolverInterface.hpp.

int OsiCpxSolverInterface::cpxVersionMajor_`[static, private]`

CPLEX version.

Definition at line 792 of file OsiCpxSolverInterface.hpp.

int OsiCpxSolverInterface::cpxVersionMinor_`[static, private]`

CPLEX environment pointer.

Definition at line 793 of file OsiCpxSolverInterface.hpp.

int OsiCpxSolverInterface::cpxVersionMinorMinor_`[static, private]`

CPLEX environment pointer.

Definition at line 794 of file OsiCpxSolverInterface.hpp.

unsigned int OsiCpxSolverInterface::numInstances_`[static, private]`

Number of live problem instances.

Definition at line 796 of file OsiCpxSolverInterface.hpp.

CPXLPptr OsiCpxSolverInterface::lp_`[mutable, private]`

CPLEX model represented by this class instance.

Definition at line 841 of file OsiCpxSolverInterface.hpp.

int* OsiCpxSolverInterface::hotStartCStat_`[private]`

Hotstart information.

Definition at line 844 of file OsiCpxSolverInterface.hpp.

int OsiCpxSolverInterface::hotStartCStatSize_`[private]`

CPLEX model represented by this class instance.

Definition at line 845 of file OsiCpxSolverInterface.hpp.

int* OsiCpxSolverInterface::hotStartRStat_`[private]`

CPLEX model represented by this class instance.

Definition at line 846 of file OsiCpxSolverInterface.hpp.

int OsiCpxSolverInterface::hotStartRStatSize_`[private]`

CPLEX model represented by this class instance.

Definition at line 847 of file OsiCpxSolverInterface.hpp.

int OsiCpxSolverInterface::hotStartMaxIteration_`[private]`

CPLEX model represented by this class instance.

Definition at line 848 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::obj_`[mutable, private]`

Pointer to objective vector.

Definition at line 853 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::collower_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 856 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::colupper_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 859 of file OsiCpxSolverInterface.hpp.

char* OsiCpxSolverInterface::rowsense_`[mutable, private]`

Pointer to dense vector of row sense indicators.

Definition at line 862 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::rhs_`[mutable, private]`

Pointer to dense vector of row right-hand side values.

Definition at line 865 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::rowrange_`[mutable, private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 868 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::rowlower_`[mutable, private]`

Pointer to dense vector of row lower bounds.

Definition at line 871 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::rowupper_`[mutable, private]`

Pointer to dense vector of row upper bounds.

Definition at line 874 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::colsol_`[mutable, private]`

Pointer to primal solution vector.

Definition at line 877 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::rowsol_`[mutable, private]`

Pointer to dual solution vector.

Definition at line 880 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::redcost_`[mutable, private]`

Pointer to reduced cost vector.

Definition at line 883 of file OsiCpxSolverInterface.hpp.

double* OsiCpxSolverInterface::rowact_`[mutable, private]`

Pointer to row activity (slack) vector.

Definition at line 886 of file OsiCpxSolverInterface.hpp.

CoinPackedMatrix* OsiCpxSolverInterface::matrixByRow_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 889 of file OsiCpxSolverInterface.hpp.

CoinPackedMatrix* OsiCpxSolverInterface::matrixByCol_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 892 of file OsiCpxSolverInterface.hpp.

char* OsiCpxSolverInterface::coltype_`[private]`

Pointer to dense vector of variable types (continous, binary, integer).

Definition at line 898 of file OsiCpxSolverInterface.hpp.

int OsiCpxSolverInterface::coltypesize_`[private]`

Size of allocated memory for coltype_.

Definition at line 901 of file OsiCpxSolverInterface.hpp.

bool OsiCpxSolverInterface::probtypemip_`[mutable, private]`

Stores whether CPLEX' prob type is currently set to MIP.

Definition at line 904 of file OsiCpxSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Cgl-0.52.0/Osi/src/OsiCpx/OsiCpxSolverInterface.hpp